apiVersion: batch/v1beta1
kind: CronJob
metadata:
  name: tekton-purge-{{ tekton_name }}
  namespace: {{ buildns }}
spec:
  concurrencyPolicy: Forbid
  failedJobsHistoryLimit: 2
  jobTemplate:
    metadata:
      labels:
        name: tekton-purge-{{ tekton_name }}
    spec:
      template:
        metadata:
          labels:
            name: tekton-purge-{{ tekton_name }}
        spec:
          automountServiceAccountToken: true
          containers:
          - args:
            - -c
            - |
              kubectl get pipelineruns -n $NAMESPACE \
                | grep -v Running \
                | grep -E ' ([789]|[1-9][0-9]|[1-9][0-9][0-9]*)d' \
                | while read prname rol; \
                  do kubectl delete -n $NAMESPACE pipelinerun $prname; done
              kubectl get taskruns -n $NAMESPACE \
                | grep -v Running \
                | grep -E ' ([789]|[1-9][0-9]|[1-9][0-9][0-9]*)d' \
                | while read trname rol; \
                  do kubectl delete -n $NAMESPACE taskrun $trname; done
              kubectl get pipelineresources -n $NAMESPACE \
                | grep -E ' ([789]|[1-9][0-9]|[1-9][0-9][0-9]*)d' \
                | while read prname rol; \
                  do kubectl delete -n $NAMESPACE pipelineresource $prname; done
            command:
            - /bin/sh
            env:
            - name: NAMESPACE
              valueFrom:
                fieldRef:
                  fieldPath: metadata.namespace
            image: {{ tekton_k8s_client_image }}
            imagePullPolicy: {{ pull_policy }}
            name: tekton-purge
            resources:
              limits:
                cpu: "{{ tekton_k8s_client_cpu_limit }}"
                memory: {{ tekton_k8s_client_memory_limit }}
              requests:
                cpu: "{{ tekton_k8s_client_cpu_request }}"
                memory: {{ tekton_k8s_client_memory_request }}
{% if k8s_resource_nodes_selectors | length > 0 %}
          nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
            {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
          restartPolicy: OnFailure
          securityContext:
            runAsUser: {{ k8s_unprivileged_userid }}
  schedule: 0 1 * * *
  startingDeadlineSeconds: 120
  successfulJobsHistoryLimit: 1
  suspend: false
